<template>
  <v-container fluid>
    <v-combobox
      label="Friends to share"
      v-model="model"
      :items="items"
      v-on:update:search-input="loadNewFriends"
      multiple
      rounded
      solo
      no-filter>
      <template v-slot:no-data>
        <v-list-item>
          <span>No matching friends</span>
        </v-list-item>
      </template>
      <template v-slot:selection="{ item, parent }">
        <v-chip
          label
          small
          @click="parent.selectItem(item)">
            {{ item.text }}
        </v-chip>
      </template>
    </v-combobox>
  </v-container>
</template>

<script>
import { GetUsers } from '@/api/users'
import { mapGetters, mapMutations } from 'vuex'

export default {
  name: "FriendsPool",

  data: () => ({
    items: [
      { header: 'Find friends to share picture with' }
    ],
    model: [],
    canFetch: true
  }),

  computed: {
    ...mapGetters([
      'usersSharedWith'
    ])
  },

  methods: {
    ...mapMutations([
      'updateUsersSharedWith'
    ]),

    updateCanFetch() {
      this.canFetch = true
    },

    async loadNewFriends(input) {
      if (input === null || !this.canFetch) {
        return
      }
      this.canFetch = false
      setTimeout(this.updateCanFetch, 500)

      if (input === '') {
        this.putNewFriends(await GetUsers({ friends: true }, 5))
        return
      }

      const names = input.split(' ')
      if (names.length === 1) {
        this.putNewFriends(await GetUsers({ anyName: names[0], friends: true }, 5))
      } else {
        this.putNewFriends(await GetUsers({ firstName: names[0], lastName: names[1], friends: true }, 5))
      }
    },

    putNewFriends(response) {
      if (!response.status) {
        return
      }

      if (response.status !== 200) {
        this.$toasted.error('Oh no... Something bad happened')
      }

      const newItems = [{ header: 'Find friends to share picture with' }]
      // I honestly have no idea how this resolves the problem that we are getting
      // friends that already has permission but not marked is list. I'm gonna leave this like this though
      response.data.data.data.forEach(e => {
        if (this.model.indexOf(item => {
          if (item.value === e.id) { return true }
        }) === -1) {
          newItems.push({
            text: e.attributes.first_name + ' ' + e.attributes.last_name,
            value: e.id
          })
        }
      })

      this.$set(this, 'items', [...newItems])
    }
  },

  watch: {
    model(val, prev) {
      if (val.length === prev.length) return

      // Filtering out values that are done by input and enter key + duplicates
      this.model = val.filter(v => typeof v !== 'string')

      this.updateUsersSharedWith(Array.from(this.model, e => e.value))
    }
  },

  async created() {
    this.model = this.usersSharedWith
    this.putNewFriends(await GetUsers({ friends: true }, 5))
  }
}
</script>

<style>
.v-chip__content {
  font-size: 15px;
}
</style>
